diff --git a/configure.ac b/configure.ac
index 8eb37a2..8c0908a 100644
--- a/configure.ac
+++ b/configure.ac
@@ -59,6 +59,8 @@ AC_ARG_WITH(nas,       AS_HELP_STRING([--without-nas],[do not use the NAS sound
             [if test "x$withval" = "xno"; then ac_cv_header_audio_audiolib_h=no; fi])
 AC_ARG_WITH(openal,    AS_HELP_STRING([--without-openal],[do not use OpenAL]),
             [if test "x$withval" = "xno"; then ac_cv_header_AL_al_h=no; ac_cv_header_OpenAL_al_h=no; fi])
+AC_ARG_WITH(dns-sd,    AS_HELP_STRING([--without-dns-sd],[do not use Bonjour]),
+            [if test "x$withval" = "xno"; then ac_cv_header_dns_sd_h=no; fi])
 AC_ARG_WITH(opengl,    AS_HELP_STRING([--without-opengl],[do not use OpenGL]))
 AC_ARG_WITH(openssl,   AS_HELP_STRING([--without-openssl],[do not use OpenSSL]),
             [if test "x$withval" = "xno"; then ac_cv_header_openssl_err_h=no; ac_cv_header_openssl_ssl_h=no; fi])
@@ -325,6 +327,7 @@ AC_CHECK_HEADERS(\
 	direct.h \
 	dirent.h \
 	dlfcn.h \
+	dns_sd.h \
 	elf.h \
 	float.h \
 	fnmatch.h \
@@ -1460,6 +1463,27 @@ WINE_NOTICE_WITH(openal,[test "x$ac_cv_lib_openal_alGetSource3i" != xyes],
                  [libopenal ${notice_platform}development files not found (or too old), OpenAL won't be supported.])
 test "x$ac_cv_lib_openal_alGetSource3i" = xyes || enable_openal32=${enable_openal32:-no}
 
+dnl **** Check for libdns_sd ****
+if test "$ac_cv_header_dns_sd_h" = "yes"
+then
+dnl Mac OS X has the dns functions in its main library libSystem
+dnl so we don't need to check for it
+    case $host_os in
+      darwin*|macosx*)
+        ;;
+      *)
+        AC_CHECK_LIB(dns_sd,DNSServiceRegister,[AC_SUBST(LIBDNSSD,"-ldns_sd")])
+    esac
+fi
+case $host_os in
+  darwin*|macosx*)
+;;
+  *)
+    WINE_NOTICE_WITH(openal,[test "x$ac_cv_lib_dns_sd_DNSServiceRegister" != xyes],
+                 [libdns_sd ${notice_platform}development files not found (or too old), mDNS won't be supported.])
+    test "x$ac_cv_lib_dns_sd_DNSServiceRegister" = xyes || enable_dns-sd=${enable_dns-sd:-no}
+esac
+
 dnl **** Check for libkstat ****
 if test "$ac_cv_header_kstat_h" = "yes"
 then
@@ -2255,6 +2279,7 @@ WINE_CONFIG_DLL(dmusic)
 WINE_CONFIG_DLL(dmusic32,,[dmusic32])
 WINE_CONFIG_DLL(dnsapi,,[dnsapi])
 WINE_CONFIG_TEST(dlls/dnsapi/tests)
+WINE_CONFIG_DLL(dnssd)
 WINE_CONFIG_DLL(dplay,,[dplay])
 WINE_CONFIG_DLL(dplayx,,[dplayx])
 WINE_CONFIG_TEST(dlls/dplayx/tests)
diff --git a/dlls/dnssd/dnssd.c b/dlls/dnssd/dnssd.c
new file mode 100644
index 0000000..2d40ab5
--- /dev/null
+++ b/dlls/dnssd/dnssd.c
@@ -0,0 +1,277 @@
+/*
+ * dnssd.dll thunk. Wraps Win32 DNS-SD function calls around a native
+ * implementation.
+ *
+ * Copyright 2010 C.W. Betts
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
+ */
+
+#include "config.h"
+
+#include <stdarg.h>
+#include <string.h>
+
+#include "windef.h"
+#include "winbase.h"
+#include "wine/debug.h"
+
+#include <dns_sd.h>
+
+WINE_DEFAULT_DEBUG_CHANNEL(dnssd);
+
+BOOL WINAPI DllMain(HINSTANCE hInstDLL, DWORD fdwReason, LPVOID lpv)
+{
+    switch(fdwReason)
+    {
+        case DLL_WINE_PREATTACH:
+            return FALSE;  /* prefer native version */
+        case DLL_PROCESS_ATTACH:
+            DisableThreadLibraryCalls(hInstDLL);
+            break;
+        case DLL_PROCESS_DETACH:
+            break;
+    }
+    return TRUE;
+}
+
+DNSServiceErrorType CDECL wine_DNSServiceGetProperty (char *attr,\
+void *result, uint32_t *size)
+{
+    return DNSServiceGetProperty(attr, result, size);    
+}
+
+int CDECL wine_DNSServiceRefSockFD(DNSServiceRef sdRef)
+{
+    return DNSServiceRefSockFD(sdRef);
+}
+
+DNSServiceErrorType CDECL wine_DNSServiceProcessResult(DNSServiceRef sdRef)
+{
+    return DNSServiceProcessResult(sdRef);
+}
+
+
+void CDECL wine_DNSServiceRefDeallocate(DNSServiceRef sdRef)
+{
+    DNSServiceRefDeallocate(sdRef);
+}
+
+DNSServiceErrorType CDECL wine_DNSServiceEnumerateDomains\
+(DNSServiceRef *sdRef, DNSServiceFlags flags, uint32_t interfaceIndex, DNSServiceDomainEnumReply callBack, void *context)
+{
+    return DNSServiceEnumerateDomains(sdRef, flags, interfaceIndex, callBack, context);
+}
+
+DNSServiceErrorType CDECL wine_DNSServiceRegister \
+(DNSServiceRef *sdRef, DNSServiceFlags flags, uint32_t interfaceIndex, const char *name, const char *regtype, const char *domain, const char *host, uint16_t port, uint16_t txtLen, const void *txtRecord, DNSServiceRegisterReply callBack, void *context)
+{
+    return DNSServiceRegister(sdRef, flags, interfaceIndex, name, regtype, domain, host, port, txtLen, txtRecord, callBack, context);
+}
+
+
+DNSServiceErrorType CDECL wine_DNSServiceAddRecord
+    (
+    DNSServiceRef                       sdRef,
+    DNSRecordRef                        *RecordRef,
+    DNSServiceFlags                     flags,
+    uint16_t                            rrtype,
+    uint16_t                            rdlen,
+    const void                          *rdata,
+    uint32_t                            ttl
+    )
+{
+    return DNSServiceAddRecord(sdRef, RecordRef, flags, rrtype, rdlen, rdata, ttl);
+}
+
+DNSServiceErrorType CDECL wine_DNSServiceUpdateRecord
+    (
+    DNSServiceRef sdRef,
+    DNSRecordRef RecordRef,
+    DNSServiceFlags flags,
+    uint16_t rdlen,
+    const void *rdata,
+    uint32_t ttl
+    )
+{
+    return DNSServiceUpdateRecord(sdRef, RecordRef, flags, rdlen, rdata, ttl);
+}
+
+DNSServiceErrorType CDECL wine_DNSServiceRemoveRecord \
+(DNSServiceRef sdRef, DNSRecordRef RecordRef, DNSServiceFlags flags)
+{
+    return DNSServiceRemoveRecord(sdRef, RecordRef, flags);
+}
+
+
+DNSServiceErrorType CDECL wine_DNSServiceBrowse
+    (
+    DNSServiceRef                       *sdRef,
+    DNSServiceFlags                     flags,
+    uint32_t                            interfaceIndex,
+    const char                          *regtype,
+    const char                          *domain,    /* may be NULL */
+    DNSServiceBrowseReply               callBack,
+    void                                *context    /* may be NULL */
+    )
+{
+    return DNSServiceBrowse(sdRef, flags, interfaceIndex, regtype, domain, callBack, context);
+}
+
+DNSServiceErrorType CDECL wine_DNSServiceResolve
+    (
+    DNSServiceRef                       *sdRef,
+    DNSServiceFlags                     flags,
+    uint32_t                            interfaceIndex,
+    const char                          *name,
+    const char                          *regtype,
+    const char                          *domain,
+    DNSServiceResolveReply              callBack,
+    void                                *context  /* may be NULL */
+    )
+{
+    return DNSServiceResolve(sdRef, flags, interfaceIndex, name, regtype, domain, callBack, context);
+}
+
+DNSServiceErrorType CDECL wine_DNSServiceCreateConnection(DNSServiceRef *sdRef)
+{
+    return DNSServiceCreateConnection(sdRef);
+}
+
+DNSServiceErrorType CDECL wine_DNSServiceRegisterRecord
+    (
+    DNSServiceRef                       sdRef,
+    DNSRecordRef                        *RecordRef,
+    DNSServiceFlags                     flags,
+    uint32_t                            interfaceIndex,
+    const char                          *fullname,
+    uint16_t                            rrtype,
+    uint16_t                            rrclass,
+    uint16_t                            rdlen,
+    const void                          *rdata,
+    uint32_t                            ttl,
+    DNSServiceRegisterRecordReply       callBack,
+    void                                *context    /* may be NULL */
+    )
+{
+    return DNSServiceRegisterRecord(sdRef, RecordRef, flags, interfaceIndex, fullname, rrtype, rrclass, rdlen, rdata, ttl, callBack, context);
+}
+
+DNSServiceErrorType CDECL wine_DNSServiceQueryRecord
+    (
+    DNSServiceRef                       *sdRef,
+    DNSServiceFlags                     flags,
+    uint32_t                            interfaceIndex,
+    const char                          *fullname,
+    uint16_t                            rrtype,
+    uint16_t                            rrclass,
+    DNSServiceQueryRecordReply          callBack,
+    void                                *context  /* may be NULL */
+    )
+{
+    return DNSServiceQueryRecord(sdRef, flags, interfaceIndex, fullname, rrtype, rrclass, callBack, context);
+}
+
+void CDECL wine_DNSServiceReconfirmRecord
+    (
+    DNSServiceFlags                    flags,
+    uint32_t                           interfaceIndex,
+    const char                         *fullname,
+    uint16_t                           rrtype,
+    uint16_t                           rrclass,
+    uint16_t                           rdlen,
+    const void                         *rdata
+    )
+{
+    DNSServiceReconfirmRecord(flags, interfaceIndex, fullname, rrtype, rrclass, rdlen, rdata);
+}
+
+int CDECL wine_DNSServiceConstructFullName
+(char *fullName, const char *service, const char *regtype, const char *domain)
+{
+    return DNSServiceConstructFullName(fullName, service, regtype, domain);
+}
+
+void CDECL wine_TXTRecordCreate
+(TXTRecordRef *txtRecord, uint16_t bufferLen, void *buffer)
+{
+    TXTRecordCreate(txtRecord, bufferLen, buffer);
+}
+
+void CDECL wine_TXTRecordDeallocate(TXTRecordRef *txtRecord)
+{
+    TXTRecordDeallocate(txtRecord);
+}
+
+DNSServiceErrorType CDECL wine_TXTRecordSetValue
+(TXTRecordRef *txtRecord, const char *key, uint8_t valueSize, const void *value)
+{
+    return TXTRecordSetValue(txtRecord, key, valueSize, value);
+}
+
+DNSServiceErrorType CDECL wine_TXTRecordRemoveValue
+(TXTRecordRef *txtRecord, const char *key)
+{
+    return TXTRecordRemoveValue(txtRecord, key);
+}
+
+uint16_t CDECL wine_TXTRecordGetLength(const TXTRecordRef *txtRecord)
+{
+    return TXTRecordGetLength(txtRecord);
+}
+
+const void * CDECL wine_TXTRecordGetBytesPtr(const TXTRecordRef *txtRecord)
+{
+    return TXTRecordGetBytesPtr(txtRecord);
+}
+
+int CDECL wine_TXTRecordContainsKey
+    (
+    uint16_t         txtLen,
+    const void       *txtRecord,
+    const char       *key
+    )
+{
+    return TXTRecordContainsKey(txtLen, txtRecord, key);
+}
+
+const void * CDECL wine_TXTRecordGetValuePtr
+    (uint16_t txtLen, const void *txtRecord, const char *key, uint8_t *valueLen)
+{
+    return TXTRecordGetValuePtr(txtLen, txtRecord, key, valueLen);
+}
+
+uint16_t CDECL wine_TXTRecordGetCount
+    (
+    uint16_t         txtLen,
+    const void       *txtRecord
+    )
+{
+    return TXTRecordGetCount(txtLen, txtRecord);
+}
+
+DNSServiceErrorType CDECL wine_TXTRecordGetItemAtIndex
+    (
+    uint16_t         txtLen,
+    const void       *txtRecord,
+    uint16_t         index,
+    uint16_t         keyBufLen,
+    char             *key,
+    uint8_t          *valueLen,
+    const void       **value
+    )
+{
+    return TXTRecordGetItemAtIndex(txtLen, txtRecord, index, keyBufLen, key, valueLen, value);
+}
diff --git a/dlls/dnssd/dnssd.spec b/dlls/dnssd/dnssd.spec
new file mode 100644
index 0000000..0616a83
--- /dev/null
+++ b/dlls/dnssd/dnssd.spec
@@ -0,0 +1,26 @@
+@ cdecl DNSServiceGetProperty(ptr ptr ptr) wine_DNSServiceGetProperty
+@ cdecl DNSServiceRefSockFD(ptr) wine_DNSServiceRefSockFD
+@ cdecl DNSServiceProcessResult(ptr) wine_DNSServiceProcessResult
+@ cdecl DNSServiceRefDeallocate(ptr) wine_DNSServiceRefDeallocate
+@ cdecl DNSServiceEnumerateDomains(ptr long long ptr ptr) wine_DNSServiceEnumerateDomains
+@ cdecl DNSServiceRegister(ptr long long str str str str long long ptr ptr ptr) wine_DNSServiceRegister
+@ cdecl DNSServiceAddRecord(ptr ptr long long long ptr long) wine_DNSServiceAddRecord
+@ cdecl DNSServiceUpdateRecord(ptr ptr long long ptr long) wine_DNSServiceUpdateRecord
+@ cdecl DNSServiceRemoveRecord(ptr ptr long) wine_DNSServiceRemoveRecord
+@ cdecl DNSServiceBrowse(ptr long long str str ptr ptr) wine_DNSServiceBrowse
+@ cdecl DNSServiceResolve(ptr long long str str str ptr ptr) wine_DNSServiceResolve
+@ cdecl DNSServiceCreateConnection(ptr) wine_DNSServiceCreateConnection
+@ cdecl DNSServiceRegisterRecord(ptr ptr long long str long long long ptr long ptr ptr) wine_DNSServiceRegisterRecord
+@ cdecl DNSServiceQueryRecord(ptr long long str long long ptr ptr) wine_DNSServiceQueryRecord
+@ cdecl DNSServiceReconfirmRecord(long long str long long long ptr) wine_DNSServiceReconfirmRecord
+@ cdecl DNSServiceConstructFullName(str str str str) wine_DNSServiceConstructFullName
+@ cdecl TXTRecordCreate(ptr long ptr) wine_TXTRecordCreate
+@ cdecl TXTRecordDeallocate(ptr) wine_TXTRecordDeallocate
+@ cdecl TXTRecordSetValue(ptr str long ptr) wine_TXTRecordSetValue
+@ cdecl TXTRecordRemoveValue(ptr str) wine_TXTRecordRemoveValue
+@ cdecl TXTRecordGetLength(ptr) wine_TXTRecordGetLength
+@ cdecl TXTRecordGetBytesPtr(ptr) wine_TXTRecordGetBytesPtr
+@ cdecl TXTRecordContainsKey(long ptr str) wine_TXTRecordContainsKey
+@ cdecl TXTRecordGetValuePtr(long ptr str long) wine_TXTRecordGetValuePtr
+@ cdecl TXTRecordGetCount(long ptr) wine_TXTRecordGetCount
+@ cdecl TXTRecordGetItemAtIndex(long ptr long long str ptr ptr) wine_TXTRecordGetItemAtIndex
diff --git a/include/config.h.in b/include/config.h.in
index 7c34980..0662717 100644
--- a/include/config.h.in
+++ b/include/config.h.in
@@ -84,6 +84,9 @@
 /* Define to 1 if you have the `dlopen' function. */
 #undef HAVE_DLOPEN
 
+/* Define to 1 if you have the <dns_sd.h> header file. */
+#undef HAVE_DNS_SD_H
+
 /* Define to 1 if you have the <elf.h> header file. */
 #undef HAVE_ELF_H
 
@@ -549,7 +552,7 @@
 /* Define to 1 if you have the <net/route.h> header file. */
 #undef HAVE_NET_ROUTE_H
 
-/* Define to 1 if `_msg_ptr' is a member of `ns_msg'. */
+/* Define to 1 if `_msg_ptr' is member of `ns_msg'. */
 #undef HAVE_NS_MSG__MSG_PTR
 
 /* Define to 1 if the system has the type `off_t'. */
@@ -663,7 +666,7 @@
 /* Define to 1 if you have the `sched_yield' function. */
 #undef HAVE_SCHED_YIELD
 
-/* Define to 1 if `cmd' is a member of `scsireq_t'. */
+/* Define to 1 if `cmd' is member of `scsireq_t'. */
 #undef HAVE_SCSIREQ_T_CMD
 
 /* Define to 1 if you have the <scsi/scsi.h> header file. */
@@ -690,7 +693,7 @@
 /* Define to 1 if you have the `settimeofday' function. */
 #undef HAVE_SETTIMEOFDAY
 
-/* Define to 1 if `interface_id' is a member of `sg_io_hdr_t'. */
+/* Define to 1 if `interface_id' is member of `sg_io_hdr_t'. */
 #undef HAVE_SG_IO_HDR_T_INTERFACE_ID
 
 /* Define if sigaddset is supported */
@@ -699,7 +702,7 @@
 /* Define to 1 if you have the `sigaltstack' function. */
 #undef HAVE_SIGALTSTACK
 
-/* Define to 1 if `si_fd' is a member of `siginfo_t'. */
+/* Define to 1 if `si_fd' is member of `siginfo_t'. */
 #undef HAVE_SIGINFO_T_SI_FD
 
 /* Define to 1 if you have the `sigprocmask' function. */
@@ -771,67 +774,67 @@
 /* Define to 1 if you have the `strtoull' function. */
 #undef HAVE_STRTOULL
 
-/* Define to 1 if `direction' is a member of `struct ff_effect'. */
+/* Define to 1 if `direction' is member of `struct ff_effect'. */
 #undef HAVE_STRUCT_FF_EFFECT_DIRECTION
 
-/* Define to 1 if `icps_outhist' is a member of `struct icmpstat'. */
+/* Define to 1 if `icps_outhist' is member of `struct icmpstat'. */
 #undef HAVE_STRUCT_ICMPSTAT_ICPS_OUTHIST
 
-/* Define to 1 if `msg_accrights' is a member of `struct msghdr'. */
+/* Define to 1 if `msg_accrights' is member of `struct msghdr'. */
 #undef HAVE_STRUCT_MSGHDR_MSG_ACCRIGHTS
 
-/* Define to 1 if `mt_blkno' is a member of `struct mtget'. */
+/* Define to 1 if `mt_blkno' is member of `struct mtget'. */
 #undef HAVE_STRUCT_MTGET_MT_BLKNO
 
-/* Define to 1 if `mt_blksiz' is a member of `struct mtget'. */
+/* Define to 1 if `mt_blksiz' is member of `struct mtget'. */
 #undef HAVE_STRUCT_MTGET_MT_BLKSIZ
 
-/* Define to 1 if `mt_gstat' is a member of `struct mtget'. */
+/* Define to 1 if `mt_gstat' is member of `struct mtget'. */
 #undef HAVE_STRUCT_MTGET_MT_GSTAT
 
-/* Define to 1 if `name' is a member of `struct option'. */
+/* Define to 1 if `name' is member of `struct option'. */
 #undef HAVE_STRUCT_OPTION_NAME
 
-/* Define to 1 if `sin6_scope_id' is a member of `struct sockaddr_in6'. */
+/* Define to 1 if `sin6_scope_id' is member of `struct sockaddr_in6'. */
 #undef HAVE_STRUCT_SOCKADDR_IN6_SIN6_SCOPE_ID
 
-/* Define to 1 if `sa_len' is a member of `struct sockaddr'. */
+/* Define to 1 if `sa_len' is member of `struct sockaddr'. */
 #undef HAVE_STRUCT_SOCKADDR_SA_LEN
 
-/* Define to 1 if `sun_len' is a member of `struct sockaddr_un'. */
+/* Define to 1 if `sun_len' is member of `struct sockaddr_un'. */
 #undef HAVE_STRUCT_SOCKADDR_UN_SUN_LEN
 
-/* Define to 1 if `f_bavail' is a member of `struct statfs'. */
+/* Define to 1 if `f_bavail' is member of `struct statfs'. */
 #undef HAVE_STRUCT_STATFS_F_BAVAIL
 
-/* Define to 1 if `f_bfree' is a member of `struct statfs'. */
+/* Define to 1 if `f_bfree' is member of `struct statfs'. */
 #undef HAVE_STRUCT_STATFS_F_BFREE
 
-/* Define to 1 if `f_favail' is a member of `struct statfs'. */
+/* Define to 1 if `f_favail' is member of `struct statfs'. */
 #undef HAVE_STRUCT_STATFS_F_FAVAIL
 
-/* Define to 1 if `f_ffree' is a member of `struct statfs'. */
+/* Define to 1 if `f_ffree' is member of `struct statfs'. */
 #undef HAVE_STRUCT_STATFS_F_FFREE
 
-/* Define to 1 if `f_frsize' is a member of `struct statfs'. */
+/* Define to 1 if `f_frsize' is member of `struct statfs'. */
 #undef HAVE_STRUCT_STATFS_F_FRSIZE
 
-/* Define to 1 if `f_namelen' is a member of `struct statfs'. */
+/* Define to 1 if `f_namelen' is member of `struct statfs'. */
 #undef HAVE_STRUCT_STATFS_F_NAMELEN
 
-/* Define to 1 if `f_blocks' is a member of `struct statvfs'. */
+/* Define to 1 if `f_blocks' is member of `struct statvfs'. */
 #undef HAVE_STRUCT_STATVFS_F_BLOCKS
 
-/* Define to 1 if `st_atim' is a member of `struct stat'. */
+/* Define to 1 if `st_atim' is member of `struct stat'. */
 #undef HAVE_STRUCT_STAT_ST_ATIM
 
-/* Define to 1 if `st_blocks' is a member of `struct stat'. */
+/* Define to 1 if `st_blocks' is member of `struct stat'. */
 #undef HAVE_STRUCT_STAT_ST_BLOCKS
 
-/* Define to 1 if `st_ctim' is a member of `struct stat'. */
+/* Define to 1 if `st_ctim' is member of `struct stat'. */
 #undef HAVE_STRUCT_STAT_ST_CTIM
 
-/* Define to 1 if `st_mtim' is a member of `struct stat'. */
+/* Define to 1 if `st_mtim' is member of `struct stat'. */
 #undef HAVE_STRUCT_STAT_ST_MTIM
 
 /* Define to 1 if the system has the type `struct xinpgen'. */
@@ -1074,7 +1077,7 @@
 /* Define to 1 if you have the <X11/Xutil.h> header file. */
 #undef HAVE_X11_XUTIL_H
 
-/* Define to 1 if `callback' is a member of `XICCallback'. */
+/* Define to 1 if `callback' is member of `XICCallback'. */
 #undef HAVE_XICCALLBACK_CALLBACK
 
 /* Define if you have the XKB extension */
@@ -1137,9 +1140,6 @@
 /* Define to the one symbol short name of this package. */
 #undef PACKAGE_TARNAME
 
-/* Define to the home page for this package. */
-#undef PACKAGE_URL
-
 /* Define to the version of this package. */
 #undef PACKAGE_VERSION
 
